
class Punto implements Ordinabile {

	int x; int y;
   	
   	public Punto (int x, int y) {
   		this.x = x;
   		this.y = y;
   	}
   	
   	int leggiX() { return x; }
   	int leggiY() { return y; }
   	
   	int distanza() {
      	return (int) Math.sqrt(x * x + y * y);
    }
   	
  //overriding
   	public String toString() {
   		return "("+ x + "," + y + ")";
   	}

   	//overriding
   	public boolean equals(Object obj) {
   		if (obj == null) return false;
   		if (!(obj instanceof Punto)) return false;
   		Punto p = (Punto) obj;
   		return ((x == p.x) && (y == p.y));
   	}
   	   	
   	
    public boolean maggioreDi (Ordinabile o) {
    	   // criterio dordinamento la distanza dallorigine
    	      	if (o instanceof Punto) 
    	         return distanza() > ((Punto) o).distanza();
    	      	else
    	         return false;
    	   }
}
