class VettoreOrdinato {
   private Ordinabile vettore[];
   private int maxDim;  //dimensione massima
   private int curDim;  //dimensione effettiva

public VettoreOrdinato (int maxDim) {
      this.maxDim = maxDim;
	vettore = new Ordinabile[maxDim];
	curDim = 0;
   }

public boolean aggiungi (Ordinabile elemento) {
    if (elemento != null && curDim < maxDim) {
	   vettore[curDim++] = elemento;
       return true;
    } else return false;
 }

 public Ordinabile leggi (int indice) {
    if (indice >= 0 && indice < curDim)
	   return (vettore[indice]);
	else return null;
 }
 
 public int dim () { return curDim; }

 public void ordina () {   //shell-sort
     int   s, i, j, num;
     Ordinabile temp;
     num = curDim;
     for (s = num / 2; s > 0; s /= 2)
        for (i = s; i < num; i++)
           for (j = i - s; j >= 0; j -= s)
              if (vettore[j].maggioreDi (vettore[j + s])) {
                 temp = vettore[j];
                 vettore[j] = vettore[j + s];
                 vettore[j + s] = temp;
              }
  }
}

